
Redmine - Defect #12680

Estimated Time value is corrupted

2012-12-27 12:33 - Konstantin K.

Status: Confirmed Start date:  

Priority: Low Due date:  

Assignee:  % Done: 0%

Category: Issues planning Estimated time: 0.00 hour

Target version:    

Resolution:  Affected version: 2.1.4

Description

Estimated Time value is corrupted.

Steps to reproduce:

1. Open an issue.

2. Set Estimated Time to '999999999999999999999999999999'.

Expected results:

Estimated Time is equal to '999999999999999999999999999999'

Actual results:

 wrong-time.jpg 

Version used:

2.1.4.stable.10927

Related issues:

Related to Redmine - Defect #12955: Misbehaviour in estimated time validation Closed

History

#1 - 2013-01-02 09:17 - Jean-Philippe Lang

- Status changed from New to Confirmed

Yes, this happends when we exceed the floating-point precision:

irb(main):001:0> "%02f" % 999999999999999999999999999999.0

=> "1000000000000000019884624838656.000000" 

 A solution would be to validate the estimated time against a reasonable range of values (eg. 0 - 1000000), what do you think?

#2 - 2013-01-26 10:45 - Daniel Felix

Hi Jean-Philippe,

I give some other solution on #12955.

What do you think about changing the datatype from float to decimal, which is much more accurate? We're using decimal in all of hour analytics,

because it behaves greater on converting, has a better support for such big numbers without falling back to exponentials and is supported in all

databases too.

This would solve this problem without the limitation of the estimated time to some value like 1.000.000.

#3 - 2013-01-27 17:17 - Jean-Philippe Lang

A numeric column still have a limitation. But the question is: do we really need to store estimated times greater than 1,000,000?

#4 - 2013-01-27 17:41 - Mischa The Evil

Jean-Philippe Lang wrote:

[...] But the question is: do we really need to store estimated times greater than 1,000,000?

 I don't think so. IMO a sane range-validation is the most pragmatic solution to workaround these - extreme edge-case - issues.
#5 - 2013-01-27 22:12 - Daniel Felix

But even with some limitation to 1.000.000, the risk of some floating point errors in timelog reports could occur. Well a good limitation would be ok, but

the datatype still isn't the best.
